const express = require('express');
const apn = require('apn');
const app = express();
const port = 3005; // Change this port if needed
const { v4: uuidv4 } = require('uuid');


const options = {
  token: {
    key: '/home/cmoldstest/public_html/village-nanny-voip/AuthKey_Z9Q744FAA6.p8',
    keyId: 'Z9Q744FAA6',
    teamId: '3ZG53CCNMB'
  },
  production: true
};
const apnProvider = new apn.Provider(options);

app.use(express.json());

app.post('/sendApnsNow', (req, res) => {
  const { tokens, payload } = req.body;

  // Sending the voip notification
  let notification = new apn.Notification();
  notification.body = payload.body;
  notification.topic = "com.villagenanny.voip"; // Make sure to append .voip here!
  notification.payload = {
    "aps": { "content-available": 1 },
    "handle": "1111111",
    "details":{
        "caller_name" :  payload.details.caller_name,
        "caller_id": payload.details.caller_id,
        "user_id": payload.details.user_id,
        "id": payload.details.user_id,
        "caller_nam" : payload.details.full_name,
        "caller_image" : payload.details.profile_image,
        "body" : payload.body,
        "object_id" : payload.user_id,
        "actor_id" : payload.id,
        "actor_type" : 'App\Models\User',
        "type" : 'incoming_call',
        "object" : 'incoming_call'
    },
    "caller_name": payload.details.caller_name,
    "caller_id": payload.details.caller_id,
      "uuid": uuidv4()

  };
  
  console.log( payload.details.caller_name);
  console.log( payload);

  apnProvider.send(notification, tokens).then(response => {
    console.log(response);
    res.json({ success: true, response });
  }).catch(error => {
    console.error(error);
    res.status(500).json({ success: false, error: error.message });
  });
});

app.listen(port, () => {
  console.log(`Server is running on port ${port}`);
});
