<?php

namespace App\Helpers;

use Stripe\StripeClient;

class Stripe
{
    public function __construct()
    {
        $this->return_url = url('/card/callback');
        $this->stripe = new StripeClient(env('STRIPE_SECRET'));
    }

    public function getPaymentIntent($intent_id)
    {
        return $this->stripe->paymentIntents->retrieve($intent_id);
    }

    public function getSetupIntent($intent_id)
    {
        return $this->stripe->setupIntents->retrieve($intent_id, []);
    }
}
