<?php

namespace App\Http\Controllers;

use App\Http\Resources\ActivityResource;
use App\Http\Resources\PaginationCollection;
use App\Models\Activity;
use App\Traits\HashId;
use App\Traits\Response;
use Illuminate\Http\Request;

class ActivityController extends Controller
{
    use Response, HashId;

    public function index()
    {
        $activities = auth()->user()->acitivities()->with(['actor', 'user'])->paginate(10);
        return $this->response(new PaginationCollection($activities, 'activities', ActivityResource::class), 200);
    }
}
