<?php

namespace App\Http\Controllers;

use App\Models\BlockUser;
use App\Traits\HashId;
use App\Traits\Response;
use Illuminate\Http\Request;

class BlockUserController extends Controller
{
    use Response, HashId;

    public function index()
    {
        $blocked = auth()->user()->blockedUsers()->get();
        return $this->response($blocked, 200);
    }
    public function add($id)
    {

        $blockedUsers = auth()->user()->favoriteUsers()->pluck('favorite_id');

        if ($blockedUsers->contains($id)) {
            return $this->response('', 200, false,['You marked this user favourite.']);
        }

        $blocked = auth()->user()->blockedUsers()->attach($id);
        return $this->response($blocked, 200);
    }
    public function remove($id)
    {
        $blocked = auth()->user()->blockedUsers()->detach($id);
        return $this->response($blocked, 200);
    }
}
