<?php

namespace App\Http\Controllers;

use App\Traits\HashId;
use App\Traits\Response;
use Illuminate\Http\Request;

class FavoriteUserController extends Controller
{
    use Response, HashId;

    public function index()
    {
        $blocked = auth()->user()->favoriteUsers()->get();
        return $this->response($blocked, 200);
    }
    public function add($id)
    {
        $blocked = auth()->user()->favoriteUsers()->attach($id);
        return $this->response($blocked, 200);
    }
    public function remove($id)
    {
        $blocked = auth()->user()->favoriteUsers()->detach($id);
        return $this->response($blocked, 200);
    }
}
