<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Models\State;
use App\Models\City;
use App\Helpers\Helper;
use App\Models\Country;

class LocationController extends Controller
{
    /**
     * Get states
     *
     * @return JsonResponse
     */
    public function getStates(Request $request)
    {
        if($request->has('country_id')){
            $data = State::where('country_id', $request->country_id)->get();
            return Helper::response(['states' => $data], 200,false);
        }else if($request->has('state_id')){
            $data = City::where('state_id', $request->state_id)->get();
            return Helper::response(['cities' => $data], 200,false);
        }else{
            $data = Country::all();
            return Helper::response(['countries' => $data], 200,false);
        }
    }
}
