<?php

namespace App\Http\Controllers;

use App\Events\PostActionNotification;
use App\Models\Message;
use App\Traits\Response;
use Illuminate\Http\Request;

class MessageController extends Controller
{
    use Response;
    public function create(Request $request)
    {
        $input = $request->all();
        $input['user_id'] = auth()->user()->id;
        $message = Message::firstOrCreate(['appointment_id' => $request->oppointment_id],$input);
        event(new PostActionNotification(
            [$input['receiver_id']],
            ['App\Models\User'],
            [
                'title' => 'New Message From ' .auth()->user()->full_name,
                'body' => 'New Message From ' .auth()->user()->full_name,
                'object_id' => $input['appointment_id'],
                'actor_id' => auth()->user()->id,
                'actor_type' => 'App\Models\User',
                'type' => 'new_message',
                'object' => 'new message',
                'custom' => [
                    'message' => $input['message'],
                ],
            ],
            null,
            false
        ));
        return $this->response($message, 201, false, ['message sent successfully']);
    }

    public function show($id)
    {
        $messages = Message::where('appointment_id',$id)->with('user')->OrderBy('id', 'desc')->get();
        if($messages){
        return $this->response($messages, 200, false, ['All messages']);
        }
        return $this->response('', 404, false, ['Not Found']);


    }
}
