<?php

namespace App\Http\Controllers;

use App\Http\Resources\CategoriesResource;
use App\Http\Resources\PreferencesResource;
use App\Models\Category;
use App\Models\Preference;
use App\Traits\HashId;
use App\Traits\Response;
use Illuminate\Http\Request;

class PreferenceController extends Controller
{
    use HashId, Response;

    public function preferencesCategories()
    {
        $preferences = Preference::get();
        $categories = Category::get();

        return $this->response(["preferences" => PreferencesResource::collection($preferences), "categories" => CategoriesResource::collection($categories)], 200);
    }
}
