<?php

namespace App\Http\Controllers;

use App\Helpers\Helper;
use App\Models\Package;
use App\Models\Setting;
use App\Models\Subscription;
use App\Models\User;
use App\Traits\HashId;
use App\Traits\PushNotification;
use App\Traits\Response;
use Carbon\Carbon;
use Illuminate\Http\Request;

class SubscriptionController extends Controller
{
    use HashId, Response, PushNotification;

        /**
     * Create stripe customer
     *
     * @param Request $request
     * @return JsonResponse
     */
    public function subscribe(Request $request)
    {
        // if (empty($this->getActiveSubscription())) {
        //     $customer = $this->createStripeCustomer();

        //     try {
        //         $this->createStripeCard($customer, $request->token);
        //     } catch (\Exception $e) {
        //         return $this->responseHelper([], 406, [$e->getMessage()]);
        //     }

        //     PackageSubscribed::dispatch(
        //         $charge = $this->charge($customer, $request->payment_amount), Package::find($request->package_id)
        //     );

        //     return $this->responseHelper(auth()->user()->fresh(), 200);
        // }

        $input = $request->all();

        $input['user_id'] = $request->user()->id;
        $input['status'] = 'active';
        $package = Package::where('id',$input['package_id'])->first();
        if($package == null){
            return $this->response('', 404, false,['Package not found']);
        }
        $input['package_id'] = $package->id;
        $input['end_date'] = Carbon::now()->addMonths($package->number_of_months)->format('d-m-Y');
        // $input['amount'] = $package->total_amount;
        //$input['end_date'] = Carbon::now()->addMonths($package->no_of_months);
        // $package->total_amount;
        $subscription = Subscription::create( $input );
        if(auth()->user()->referred_by != null && auth()->user()->referred_paid == 0){
            $amount = Setting::first();
            $referred_by = User::where('referral_code',auth()->user()->referred_by)->first();




            $refferd_by_amount = $referred_by->wallet->deposit($amount->referral_amount, "referral amount");
            $user_amount = auth()->user()->wallet->deposit($amount->referral_amount, "referred amount");
            $this->sendReferralNotification($referred_by->id, 'App\Models\User', $user_amount->id,auth()->user()->id);
            $user = User::find(auth()->user()->id);
            $user->referred_paid = 1 ;
            $user->save();
        }
        return $this->response(['subscription' => $subscription], 200, false, ['Subscribed Successfully']);
    }

    public function getSubscription(Request $request)
    {
        $subs = auth()->user()->subscriptions()->latest()->first();
        return $this->response(['subscription' => $subs], 200, false, []);
    }
}
