<?php

namespace App\Http\Controllers;

use App\Models\User;
use App\Traits\HashId;
use App\Traits\Response;
use Carbon\Carbon;
use Illuminate\Http\Request;

class UserScheduleController extends Controller
{
    use Response, HashId;
    public function update(Request $request)
    {
        foreach ($request->schedule as $key => $value) {

            $request->user()->schedule()->updateOrCreate(
                ['day' => $value['day']],
                [
                    'starttime' => Carbon::parse($value['starttime'])->format('H:i:s'),
                    'endtime' => Carbon::parse($value['endtime'])->format('H:i:s'),
                    'status' => $value['status'],
                ]
            );
        }

        return $this->response($request->user()->schedule, 200, false, ['Schedule updated successfully.']);
    }

    public function view($id)
    {
        $id = $id ? $this->decode($id) : auth()->user()->id;

        return $this->response(
            User::find($id)->schedule,
            200,
            false,
            ['Schedule fetched successfully.']
        );
    }
}
