<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Events\PostActionNotification;
use App\Helpers\Agora\RtcTokenBuilder;
use App\Helpers\Helper;
use App\Models\Appointment;
use App\Models\User;
use App\Models\UserDevice;
use App\Traits\HashId;
use App\Traits\Response;
use Exception;

use Pushok\AuthProvider\{Token, Certificate};


use GuzzleHttp\Client;


class VideoCallController extends Controller
{
    use Response, HashId;
    public function initiate(Request $request, $user_id, $type)
    {
        $auth = $request->user();

        $receiver = User::find($user_id);

        if ($type == 'publisher') {

            event(new PostActionNotification(
                [$receiver->id],
                ['App\Models\User'],
                [
                    'title' => 'Calling',
                    'body' => $auth->full_name . ' is calling you.',
                    'object_id' => $user_id,
                    'actor_id' => $auth->id,
                    'actor_type' => 'App\Models\User',
                    'type' => 'incoming_call',
                    'object' => 'incoming_call',
                    'details' => [
                        'user_id' => $this->encode($user_id),
                        'caller_id' => $this->encode($auth->id),
                        'caller_name' => $auth->full_name,
                        'caller_image' => $auth->profile_image,
                    ],
                ],
                null,
                false
            ));

            $devices = UserDevice::where('user_id', $user_id)->get();
            $ios_dev = $devices->where('device_type', 'ios')->sortByDesc('id')->pluck(['voip_token'])->toArray();

            if( sizeof( $ios_dev ) ){

                $body = json_encode([
                    "tokens" => $ios_dev[0],
                    "payload" => [
                        'title' => 'Calling',
                        'body' => $auth->full_name . ' is calling you.',
                        'object_id' => $user_id,
                        'actor_id' => $auth->id,
                        'actor_type' => 'App\Models\User',
                        'type' => 'incoming_call',
                        'object' => 'incoming_call',
                        'details' => [
                             'user_id' => $this->encode($user_id),
                            'caller_id' => $this->encode($auth->id),
                            'caller_name' => $auth->full_name,
                            'caller_image' => $auth->profile_image,
                        ],
                    ]
                ]);

                try {
                    $client = new Client();
                    $res = $client->request('post', 'http://test-cmolds.com:3005/sendApnsNow', [
                        'headers' => [
                            'Content-Type' => 'application/json',
                        ],
                        'body' => $body
                    ]);
                } catch (Exception $e) {
                    $responseString = $e->getMessage();
                    /*
                    $jsonString = substr($responseString, strpos($responseString, "{"));

                    $errorObj = json_decode($jsonString);

                    $errorMsg = $errorObj->error; */

                    return $this->response(["exception" => $e->getMessage()], 404, false, [$responseString]);
                }
            }









            // $options = [
            //     'key_id' => 'K33944JKMR', // The Key ID obtained from Apple developer account
            //     'team_id' => '3ZG53CCNMB', // The Team ID obtained from Apple developer account
            //     'app_bundle_id' => 'com.app.nanniesonwheelz', // The bundle ID for app obtained from Apple developer account
            //     'private_key_path' => 'https://test-cmolds.com/nannies-api/' . 'private_key.p8', // Path to private key
            //     // 'private_key_path' => 'https://test-cmolds.com/nannies-api/' . 'Certificates.p12', // Path to private key
            //     'private_key_secret' => null // Private key secret
            // ];

            // $authProvider = Token::create($options);

            // $options = [
            //     'app_bundle_id' => 'com.app.nanniesonwheelz', // The bundle ID for app obtained from Apple developer account
            //     //'certificate_path' => __DIR__ . '/../../../cert_key.pem', // Path to private key
            //     'certificate_path' => 'https://test-cmolds.com/nannies-api/' . 'cert_key.pem', // Path to private key
            //     //'certificate_secret' => null
            //     //'certificate_secret' => __DIR__ . '/../../../dev_key.pem' // Path to private key
            //     'certificate_secret' => 'https://test-cmolds.com/nannies-api/' . 'dev_key.pem' // Path to private key
            // ];

            // $authProvider = Certificate::create($options);

            // $alert = Alert::create()->setTitle('Calling!');
            // $alert = $alert->setBody($auth->full_name . ' is calling you.');
            // //$alert = $alert->setActionLocKey('calling');

            // $payload = Payload::create()->setAlert($alert);

            // //set notification sound to default
            // $payload->setSound('default');
            // $payload->setPushType('voip');
            // $payload->setContentAvailability(true);


            // //add custom value to your notification, needs to be customized
            // $payload->setCustomValue('object', 'incoming_call');
            // $payload->addCustomValue('type', 'incoming_call');
            // $payload->addCustomValue('booking_id' , $this->encode($booking->id));
            // $payload->addCustomValue('caller_id' , $this->encode($auth->id));
            // $payload->addCustomValue('caller_name' , $auth->full_name);
            // $payload->addCustomValue('caller_image' , $auth->profile_image);
            // $devices = UserDevice::where('user_id', $receiver->id)->where('is_notify', 1)
            //     ->get();
            // // $ios_dev = $devices->where('device_type', 'ios')->pluck(['voip_token'])->toArray();
            // $ios_dev = ['0fb26cd7d86c2bba9441b984199ce444889b2481dccdabe260399336c7c3bc8f'];

            // $notifications = [];
            // foreach ($ios_dev as $deviceToken) {
            //     $notifications[] = new PushokNotification($payload, $deviceToken);
            // }

            // $client = new Client($authProvider, $production = false, [CURLOPT_SSL_VERIFYPEER=>false]);
            // $client->addNotifications($notifications);



            // $responses = $client->push(); // returns an array of ApnsResponseInterface (one Response per Notification)

            // foreach ($responses as $response) {
            //     Log::info([
            //         $response->getDeviceToken(),
            //         $response->getApnsId(),
            //         $response->getStatusCode(),
            //         $response->getReasonPhrase(),
            //         $response->getErrorReason(),
            //         $response->getErrorDescription(),
            //         $response->get410Timestamp(),
            //     ]);
            // }
        }

        $appID = "5c7b40bdb73142d3b182f2b9d12e28fd";
        $appCertificate = "6a2c943cad5047748e384b1cdefc9eb2";
        $channelName = $user_id;
        $uid = 0;
        $role = 1;
        // $role = RtcTokenBuilder::RolePublisher;
        $expireTimeInSeconds = 3600;
        $currentTimestamp = (new \DateTime("now", new \DateTimeZone('UTC')))->getTimestamp();
        $privilegeExpiredTs = $currentTimestamp + $expireTimeInSeconds;

        $token = RtcTokenBuilder::buildTokenWithUid($appID, $appCertificate, $channelName, $uid, $role, $privilegeExpiredTs);

        return $this->response([
            'RTCToken' => $token
        ]);
    }

    public function endCall($id)
    {

        $auth = auth()->user();
        $receiver = User::find($id);



        event(new PostActionNotification(
            [$receiver->id],
            ['App\Models\User'],
            [
                'title' => 'End call',
                'body' => $auth->full_name . ' ended the call.',
                'object_id' => $id,
                'actor_id' => $auth->id,
                'actor_type' => 'App\Models\User',
                'type' => 'incoming_call_end',
                'object' => 'incoming_call_end',
                'details' => [
                    'user_id' => $id,
                    'caller_id' => $auth->id,
                    'caller_name' => $auth->full_name,
                    'caller_image' => $auth->profile_image,
                ],
            ],
            null,
            false
        ));

        return $this->response("", 200, false, ['call ended successfully']);
    }
}
