<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\Rules\Password;

class UserRegistrationRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, mixed>
     */
    public function rules()
    {
        $validations = [
            'full_name' => 'required|string|max:255',

            'email' => 'required|email|min:6|max:255|unique:users',
            //            'password' => 'required|string|min:8|max:15',
            'password' => [
                'required', Password::min(8)->mixedCase()->numbers(),
                //                'regex:/((?=.*\d)|(?=.*\W+))(?![.\n])(?=.*[A-Z])(?=.*[a-z]).*$/',
                'max:15'
            ],
            "phone" => 'required|string|min:10|max:15',
            "gender" => 'sometimes|string|min:10|max:50',
            "dob" => 'sometimes|string|min:10|max:50',
            "referred_by" => 'nullable',

        ];

        return $validations;
    }

}
