<?php

namespace App\Http\Requests;

use Illuminate\Foundation\Http\FormRequest;

class UserUpdateRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        return true;
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array<string, mixed>
     */
    public function rules()
    {
        return [
            'categories' => 'required|array|min:1',
            'preferences' => 'required|array|min:1',
        ];
    }

    /**
     * Get the validation error messages.
     *
     * @return array<string, string>
     */
    public function messages()
    {
        return [
            'categories.required' => 'Please select at least one category.',
            'categories.min' => 'Please select at least one category.',
            'preferences.required' => 'Please select at least one preference.',
            'preferences.min' => 'Please select at least one preference.',
        ];
    }
}
