<?php

namespace App\Mail;

use App\Traits\HashId;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Mail\Mailable;
use Illuminate\Queue\SerializesModels;

class EmailVerificationCode extends Mailable
{
    use Queueable, SerializesModels, HashId;

    /**
     * @var $code
     */
    public $code;
    /**
     * @var $id
     */
    public $id;
    public $user;

    /**
     * Create a new message instance.
     *
     * @return void
     */
    public function __construct(string $code, $user, int $id)
    {
        $this->code = $code;
        $this->id = $this->encode($id);
        $this->user = $user;
    }

    /**
     * Build the message.
     *
     * @return $this
     */
    public function build()
    {
        return $this->view('verification.code');
    }
}
