<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Illuminate\Database\Eloquent\Casts\Attribute;


class UserSchedule extends Model
{
    use HasFactory, SoftDeletes;

    protected $fillable = [
        'user_id',
        'day',
        'starttime',
        'endtime',
        'status',
    ];

    protected function starttime(): Attribute
    {
        return Attribute::make(
            get: fn ($value) => Carbon::parse($value)->format('g:i A'),
        );
    }

    protected function endtime(): Attribute
    {
        return Attribute::make(
            get: fn ($value) => Carbon::parse($value)->format('g:i A'),
        );
    }

}
