<?php

namespace App\Observers;

use App\Models\Service;
use App\Models\User;
use App\Traits\RandomValue;
use Stripe\StripeClient;

class UserObserver
{
    use RandomValue;
    /**
     * Handle the User "created" event.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    public function created(User $customer)
    {
        // $stripe = new StripeClient(env('STRIPE_SECRET'));
        $stripe = new StripeClient('sk_test_51M927IJrBpDI5xCbvNhynslC2JVfUO4MWnCXIRYObW4nseEXwCsFnwT9pTTgzmfU8UdT8p19Pkz1HSCcKSYa5TXc00anXOVchE');
        $customer_stripe = $stripe->customers->create([
            'name' => $customer->name,
            'email' => $customer->email,
            'phone' => $customer->phone,
            'payment_method' => 'pm_card_visa',
        ]);
        do {
            $refrence_id =$this->get_rand_alphanumeric(8);
         } while ( User::where( 'referral_code', $refrence_id )->exists() );


        $customer->update([
            'customer_stripe_id' => $customer_stripe['id'],
            'referral_code' =>$refrence_id,
        ]);

        $customer->wallet()->create([
            'currency' => 'USD',
            'amount' => 0
        ]);
    }

    /**
     * Handle the User "updated" event.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    public function updated(User $user)
    {
        //
    }

    /**
     * Handle the User "deleted" event.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    public function deleted(User $user)
    {
        //
    }

    /**
     * Handle the User "restored" event.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    public function restored(User $user)
    {
        //
    }

    /**
     * Handle the User "force deleted" event.
     *
     * @param  \App\Models\User  $user
     * @return void
     */
    public function forceDeleted(User $user)
    {
        //
    }
}
