<?php

namespace App\Traits;

use Vinkla\Hashids\Facades\Hashids;



trait HashId
{

    /**
     * Encode id
     *
     * @param $id
     * @return string
     */
    public static function encode($id)
    {
        if (env('HASHIDS') && is_numeric($id)) {
            return Hashids::encode($id);
        }

        if (!env('HASHIDS') && !is_numeric($id)) {
            return Hashids::encode($id);
        }

        return (int) $id;
    }

    /**
     * Decode id
     *
     * @param $str
     * @return int
     */
    public static function decode($str)
    {
        if (env('HASHIDS') && !is_numeric($str)) {
            $decode = Hashids::decode($str);
            return (int) reset($decode);
        }

        if (!env('HASHIDS') && !is_numeric($str)) {
            $decode = Hashids::decode($str);
            return (int) reset($decode);
        }

        return (int) $str;
    }

    /**
     * Decode multiple ids
     *
     * @param $ids
     * @return array|int
     */
    public static function decodeIds($ids)
    {
        $decodedIds = [];

        foreach ($ids as $key => $value) {
            $decodedIds[$key] = self::decode($value);
        }

        return $decodedIds;
    }
}
