<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('appointments', function (Blueprint $table) {
            $table->id();
            $table->bigInteger('parent_id')->nullable();
            $table->bigInteger('booking_id')->nullable();
            $table->string('booking_type')->nullable();
            $table->bigInteger('user_id')->nullable();
            $table->bigInteger('service_provider_id')->nullable();
            $table->bigInteger('service_category_id')->nullable();
            $table->string('job_title')->nullable();
            $table->string('job_type')->nullable();
            $table->string('qualification')->nullable();
            $table->text('address')->nullable();
            $table->text('addressline2')->nullable();
            $table->double('rate_per_hour')->nullable();
            $table->enum('type',['instant','job'])->nullable();
            $table->enum('status',['accepted','pending','cancelled','completed','in_progress','acknowledged','expired','rejected'])->nullable();
            $table->string('start_date')->nullable();
            $table->string('end_date')->nullable();
            $table->time('start_time')->nullable();
            $table->time('end_time')->nullable();
            $table->time('started_at')->nullable();
            $table->string('working_hours')->nullable();
            $table->string('pay_range')->nullable();
            $table->string('ethnicity')->nullable();
            $table->string('english')->nullable();
            $table->text('description')->nullable();
            $table->text('preferences')->nullable();
            $table->text('duration')->nullable();
            $table->double('latitude')->nullable();
            $table->double('longitude')->nullable();
            $table->text('additional_notes')->nullable();
            $table->timestamp('appointment_cancel_time')->nullable();
            $table->timestamp('appointment_expire_time')->nullable();
            $table->enum('appointment_type',['recurring','onetime'])->nullable();
            $table->text('image')->nullable();
            $table->text('msg')->nullable();
            $table->string('pay_type')->nullable();
            $table->string('payment_method')->nullable();
            $table->string('transaction_reference')->nullable();
            $table->string('language')->nullable();
            $table->string('service_status')->nullable();
            $table->string('verification_code')->nullable();
            $table->boolean('is_3dsecure')->nullable();
            $table->timestamps();
            $table->softDeletes();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('appointments');
    }
};
